diff -u --recursive nginx-0.6.32/src/event/ngx_event_pipe.c nginx-0.6.32-clean/src/event/ngx_event_pipe.c
--- nginx-0.6.32/src/event/ngx_event_pipe.c	2008-07-07 00:18:41.000000000 -1000
+++ nginx-0.6.32-clean/src/event/ngx_event_pipe.c	2008-09-22 02:22:58.000000000 -1000
@@ -298,29 +298,27 @@
         p->free_raw_bufs = NULL;
 
         while (cl && n > 0) {
-
             ngx_event_pipe_remove_shadow_links(cl->buf);
 
             size = cl->buf->end - cl->buf->last;
 
             if (n >= size) {
                 cl->buf->last = cl->buf->end;
-
-                /* STUB */ cl->buf->num = p->num++;
-
-                if (p->input_filter(p, cl->buf) == NGX_ERROR) {
-                    return NGX_ABORT;
-                }
-
                 n -= size;
-                ln = cl;
-                cl = cl->next;
-                ngx_free_chain(p->pool, ln);
-
-            } else {
+	    }else{
                 cl->buf->last += n;
-                n = 0;
-            }
+		n = 0;
+	    }
+
+	    /* STUB */ cl->buf->num = p->num++;
+	    
+	    if (p->input_filter(p, cl->buf) == NGX_ERROR) {
+	      return NGX_ABORT;
+	    }
+	    
+	    ln = cl;
+	    cl = cl->next;
+	    ngx_free_chain(p->pool, ln);
         }
 
         if (cl) {
